var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { Loggable } from './log';
import 'babylonjs-loaders';
/* ASSET MODEL */
var Asset = /** @class */ (function (_super) {
    __extends(Asset, _super);
    function Asset(modelFileName) {
        var _this = _super.call(this, "Asset") || this;
        _this.meshes = [];
        // flags
        _this.isLoaded = false;
        _this.hasError = false;
        _this.fileName = modelFileName;
        _this.name = modelFileName.split(".")[0];
        return _this;
    }
    Asset.prototype.setMeshes = function (meshes) {
        var meshArray = [];
        for (var _i = 0, meshes_1 = meshes; _i < meshes_1.length; _i++) {
            var abstrMesh = meshes_1[_i];
            var mesh = abstrMesh;
            meshArray.push(mesh);
        }
        this.meshes = meshArray;
        // set root mesh name
        this.isLoaded = true;
        // set main mesh name
        var mainMesh = this.getMesh();
        if (mainMesh) {
            mainMesh.id = "asset-" + this.name;
        }
    };
    Asset.prototype.getMesh = function () {
        if (this.meshes.length < 1) {
            this.error("has no meshes loaded");
            return;
        }
        var mainMeshIndex = this.meshes.length - 1;
        var mainMesh = this.meshes[mainMeshIndex];
        return mainMesh;
    };
    Asset.prototype.getMeshInstance = function (name, autoRotate) {
        var meshInstance = this.getMesh().createInstance(name);
        return meshInstance;
    };
    Object.defineProperty(Asset.prototype, "fileExtension", {
        /* ASSET GETTERS */
        get: function () { return this.fileName.split(".")[1]; },
        enumerable: false,
        configurable: true
    });
    Asset.prototype.toString = function () {
        return "<Asset \"".concat(this.name, "\" meshes=").concat(this.meshes.length, " error=").concat(this.hasError, ">");
    };
    return Asset;
}(Loggable));
export { Asset };
/* == ASSET CONSTANTS == */
export var MODEL_FOLDER_PATH = "./res/models/";
export var MODEL_FILE_ENDINGS = ["obj", "gltf", "glb"];
//# sourceMappingURL=asset.js.map