var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { Loggable } from "./log";
import { Properties } from "./properties";
/* == COMMAND MODEL == */
var BaseCommand = /** @class */ (function (_super) {
    __extends(BaseCommand, _super);
    function BaseCommand(id, commandable, props) {
        var _this = _super.call(this, "BaseCommand") || this;
        _this.props = new Properties();
        _this.justOnce = true;
        _this.id = id;
        if (commandable) {
            _this.commandable = commandable;
        }
        if (props) {
            _this.props = props;
        }
        return _this;
    }
    Object.defineProperty(BaseCommand.prototype, "canExecute", {
        get: function () {
            if (this.commandable) {
                return true;
            }
            return false;
        },
        enumerable: false,
        configurable: true
    });
    BaseCommand.prototype.checkCanExecute = function () {
        if (!this.canExecute) {
            this.error("cant execute! no commandable assigned");
            return false;
        }
        return true;
    };
    BaseCommand.prototype.onEnter = function () {
    };
    BaseCommand.prototype.onTurn = function () {
        if (!this.checkCanExecute()) {
            return;
        }
        return this.justOnce;
    };
    BaseCommand.prototype.onExit = function () {
    };
    BaseCommand.prototype.toString = function () {
        return "<Cmd \"".concat(this.id, "\">");
    };
    return BaseCommand;
}(Loggable));
export { BaseCommand };
/* == COMMAND QUEUE == */
var CommandQueue = /** @class */ (function () {
    function CommandQueue() {
    }
    CommandQueue.prototype.add = function (cmd) {
        throw new Error("Method not implemented.");
    };
    CommandQueue.prototype.endCurrent = function () {
        throw new Error("Method not implemented.");
    };
    CommandQueue.prototype.onTurn = function () {
        throw new Error("Method not implemented.");
    };
    Object.defineProperty(CommandQueue.prototype, "current", {
        get: function () {
            if (this.queue && this.queue.length > 0) {
                return this.queue[0];
            }
            return null;
        },
        enumerable: false,
        configurable: true
    });
    return CommandQueue;
}());
export { CommandQueue };
//# sourceMappingURL=command.js.map