var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { BaseEventListener } from "./events";
import { EntityHeader } from "./entity-header";
import { Loggable } from "./log";
import { WorldTools } from "../helpers/world-tools";
/* BASE ENTITY */
var AbstractEntity = /** @class */ (function (_super) {
    __extends(AbstractEntity, _super);
    function AbstractEntity(num) {
        var _this = _super.call(this, "Entity") || this;
        _this.num = -1;
        _this.num = num;
        _this.header = new EntityHeader(_this);
        return _this;
    }
    AbstractEntity.prototype.onTurn = function () {
    };
    Object.defineProperty(AbstractEntity.prototype, "uid", {
        get: function () { return this.header.uid(); },
        enumerable: false,
        configurable: true
    });
    return AbstractEntity;
}(Loggable));
export { AbstractEntity };
var AbstractEventEntity = /** @class */ (function (_super) {
    __extends(AbstractEventEntity, _super);
    function AbstractEventEntity(num) {
        var _this = _super.call(this, "Entity") || this;
        _this.num = -1;
        _this.num = num;
        _this.header = new EntityHeader(_this);
        return _this;
    }
    AbstractEventEntity.prototype.onTurn = function () {
    };
    Object.defineProperty(AbstractEventEntity.prototype, "uid", {
        get: function () { return this.header.uid(); },
        enumerable: false,
        configurable: true
    });
    return AbstractEventEntity;
}(BaseEventListener));
export { AbstractEventEntity };
/* MAP ENTITY */
var WorldEntity = /** @class */ (function (_super) {
    __extends(WorldEntity, _super);
    function WorldEntity(num, pos) {
        var _this = _super.call(this, num) || this;
        _this.pos = pos;
        return _this;
    }
    Object.defineProperty(WorldEntity.prototype, "distanceToPlayer", {
        get: function () {
            if (globalThis.PLAYER && globalThis.Player.pos) {
                return WorldTools.getWorldPosDistance(this.pos, globalThis.PLAYER.pos);
            }
            return;
        },
        enumerable: false,
        configurable: true
    });
    return WorldEntity;
}(AbstractEntity));
export { WorldEntity };
var WorldEventEntity = /** @class */ (function (_super) {
    __extends(WorldEventEntity, _super);
    function WorldEventEntity(num, pos) {
        var _this = _super.call(this, num) || this;
        _this.pos = pos;
        return _this;
    }
    Object.defineProperty(WorldEventEntity.prototype, "distanceToPlayer", {
        get: function () {
            if (globalThis.PLAYER && globalThis.Player.pos) {
                return WorldTools.getWorldPosDistance(this.pos, globalThis.PLAYER.pos);
            }
            return;
        },
        enumerable: false,
        configurable: true
    });
    return WorldEventEntity;
}(AbstractEventEntity));
export { WorldEventEntity };
/* COMMANDABLE */
var CommandableMapEntity = /** @class */ (function (_super) {
    __extends(CommandableMapEntity, _super);
    function CommandableMapEntity() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.commands = [];
        return _this;
    }
    CommandableMapEntity.prototype.onCommand = function (cmd) {
    };
    CommandableMapEntity.prototype.addCommand = function (cmd) {
    };
    return CommandableMapEntity;
}(WorldEntity));
export { CommandableMapEntity };
/* MOVABLE ENTITY */
var MovableEntity = /** @class */ (function (_super) {
    __extends(MovableEntity, _super);
    function MovableEntity() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MovableEntity.prototype.moveInDir = function (dirStr) {
    };
    return MovableEntity;
}(CommandableMapEntity));
export { MovableEntity };
//# sourceMappingURL=entity.js.map