var BuildingCategory = /** @class */ (function () {
    function BuildingCategory(bldCatNum, name) {
        this.bldTypes = [];
        this._name = null;
        this.num = bldCatNum;
        if (name) {
            this._name = name;
        }
    }
    Object.defineProperty(BuildingCategory.prototype, "name", {
        get: function () {
            if (this._name && this._name.length > 0) {
                return this._name;
            }
            return "";
        },
        enumerable: false,
        configurable: true
    });
    BuildingCategory.prototype.addBldType = function (bldType) {
        this.bldTypes.push(bldType);
    };
    Object.defineProperty(BuildingCategory.prototype, "bldTypeIds", {
        get: function () {
            var bldTypeIds = [];
            for (var _i = 0, _a = this.bldTypes; _i < _a.length; _i++) {
                var catBldType = _a[_i];
                bldTypeIds.push(catBldType.id);
            }
            return bldTypeIds;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory.prototype, "isNone", {
        // flags
        get: function () { return this.num == BuildingCategory.NONE; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory.prototype, "isCivic", {
        get: function () { return this.num == BuildingCategory.CIVIC; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory.prototype, "isProd", {
        get: function () { return this.num == BuildingCategory.PROD; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory.prototype, "isMil", {
        get: function () { return this.num == BuildingCategory.MIL; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory.prototype, "isWorld", {
        get: function () { return this.num == BuildingCategory.WORLD; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory, "NONE", {
        // static bld type numbers
        get: function () { return 5; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory, "CIVIC", {
        get: function () { return 0; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory, "PROD", {
        get: function () { return 1; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory, "MIL", {
        get: function () { return 2; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory, "TRADER", {
        get: function () { return 4; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BuildingCategory, "WORLD", {
        get: function () { return 3; },
        enumerable: false,
        configurable: true
    });
    return BuildingCategory;
}());
export { BuildingCategory };
/* == BUILDING CAT VALUES == */
export var BLDCAT_CIVIC = 0;
export var BLDCAT_PROD = 1;
export var BLDCAT_MIL = 2;
export var BLDCAT_WORLD = 3;
export var BLDCAT_TRADER = 4;
export var BLDCAT_NONE = 5;
export var CATEGORIES = [
    new BuildingCategory(BuildingCategory.CIVIC, "Civic"),
    new BuildingCategory(BuildingCategory.PROD, "Production"),
    new BuildingCategory(BuildingCategory.MIL, "Military"),
    new BuildingCategory(BuildingCategory.WORLD, "World"),
    new BuildingCategory(BuildingCategory.TRADER, "Trader"),
    new BuildingCategory(BuildingCategory.NONE, "None"),
];
//# sourceMappingURL=building-category.js.map