var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { Loggable } from "../../../common/log";
import { RandomElement } from "../../../helpers/random";
/* == CITY CULTRE MODEL == */
var CityCulture = /** @class */ (function (_super) {
    __extends(CityCulture, _super);
    function CityCulture(city, cultureKey) {
        var _this = _super.call(this, "CityCulture") || this;
        _this.key = null;
        _this.city = null;
        _this.city = city;
        var cultureKeyIsValid = cultureKey && CityCultureKeys.ALL.includes(cultureKey);
        // undefined? set to weur
        if (!cultureKeyIsValid) {
            _this.warn("cant find city mesh for culture \"".concat(cultureKey, "\"; set to \"weur\""));
            _this.key = CityCultureKeys.W_EUROPEAN;
        }
        else {
            _this.key = cultureKey; // or set cultureKey str
        }
        return _this;
    }
    Object.defineProperty(CityCulture.prototype, "meshName", {
        get: function () {
            return "city_" + this.key + ".obj";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCulture.prototype, "languageId", {
        get: function () {
            switch (this.key) {
                case CityCultureKeys.DEFAULT: return "western";
                case CityCultureKeys.HELLENIC: return "hellenic";
                case CityCultureKeys.ROMAN: return "italian";
                case CityCultureKeys.W_EUROPEAN: return "western";
                case CityCultureKeys.SLAVIC: return "slavic";
                case CityCultureKeys.ASIAN: return "easian";
                case CityCultureKeys.TRIBAL: return "african";
                case CityCultureKeys.COLONIAL: return "italian";
                case CityCultureKeys.MIDEAST: return "arabic";
                case CityCultureKeys.BARBARIAN: return "germanic";
                case CityCultureKeys.CLOISTER: return "western";
                case CityCultureKeys.ELVEN: return "elven";
                case CityCultureKeys.VENETIAN: return "italian";
                case CityCultureKeys.HANSEATIC: return "germanic";
                case CityCultureKeys.VIVEC: return "elven";
                case CityCultureKeys.DWARVEN: return "germanic";
                default: return "western";
            }
        },
        enumerable: false,
        configurable: true
    });
    return CityCulture;
}(Loggable));
export { CityCulture };
/* == CITY CULTURES LIST == */
var CityCultureKeys = /** @class */ (function () {
    function CityCultureKeys() {
    }
    Object.defineProperty(CityCultureKeys, "DEFAULT", {
        get: function () { return "weur"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "MIDEAST", {
        get: function () { return "mideast"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "ASIAN", {
        get: function () { return "asian"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "TRIBAL", {
        get: function () { return "tribal"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "SLAVIC", {
        get: function () { return "slavic"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "W_EUROPEAN", {
        get: function () { return "weur"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "COLONIAL", {
        get: function () { return "colonial"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "CLOISTER", {
        get: function () { return "cloister"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "VENETIAN", {
        get: function () { return "venetian"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "HANSEATIC", {
        get: function () { return "hanseatic"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "ROMAN", {
        // ancient
        get: function () { return "roman"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "HELLENIC", {
        get: function () { return "hellenic"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "BARBARIAN", {
        get: function () { return "barbarian"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "ELVEN", {
        // fantasy
        get: function () { return "elven"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "DWARVEN", {
        get: function () { return "dwarven"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "EVIL", {
        get: function () { return "evil"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "VIVEC", {
        // unique cities
        get: function () { return "vivec"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CityCultureKeys, "ALL", {
        // list
        get: function () {
            return [CityCultureKeys.W_EUROPEAN, CityCultureKeys.MIDEAST, CityCultureKeys.ASIAN, CityCultureKeys.TRIBAL,
                CityCultureKeys.SLAVIC, CityCultureKeys.COLONIAL, CityCultureKeys.CLOISTER, CityCultureKeys.CLOISTER, CityCultureKeys.VENETIAN,
                CityCultureKeys.HANSEATIC, CityCultureKeys.ROMAN, CityCultureKeys.HELLENIC, CityCultureKeys.BARBARIAN, CityCultureKeys.ELVEN,
                CityCultureKeys.DWARVEN, CityCultureKeys.EVIL, CityCultureKeys.VIVEC];
        },
        enumerable: false,
        configurable: true
    });
    // random
    CityCultureKeys.GetRandom = function () {
        return RandomElement.of(CityCultureKeys.ALL);
    };
    return CityCultureKeys;
}());
export { CityCultureKeys };
//# sourceMappingURL=city-culture.js.map