var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// entities
import { AbstractFaction } from "./faction";
import { FACTION_TYPES, TYPE_EMPIRE } from "./faction-type";
/* == EMPIRE MODEL */
var Empire = /** @class */ (function (_super) {
    __extends(Empire, _super);
    function Empire(key, name, colors, home) {
        var _this = _super.call(this, key, name, home) || this;
        // cities
        _this._ownedCityNums = [];
        // diplomacy
        _this.diplTrait = null;
        _this.factionType = FACTION_TYPES[TYPE_EMPIRE];
        // retrieve a faction id
        _this.num = _this.getFactionNum();
        return _this;
    }
    Empire.prototype.getFactionNum = function () {
        if (!globalThis.FACTIONS) {
            this.error("cant get a faction number; Faction Manager not loaded yet");
            return;
        }
        return globalThis.FACTIONS.nextFactionNum();
    };
    Empire.prototype.getOwnedCities = function () {
        if (!globalThis.CITIES) {
            this.error("cant get owned city of ".concat(this.name, ": CityManager not loaded yet"));
        }
        var ownedCities = [];
        for (var _i = 0, _a = this._ownedCityNums; _i < _a.length; _i++) {
            var cityNum = _a[_i];
            var cityObj = globalThis.CITIES.getByNum(cityNum);
            ownedCities.push(cityObj);
        }
        return ownedCities;
    };
    Empire.prototype._giveCity = function (cityObj) {
        cityObj._ownerFactionNum = this.num;
        this.log("city ".concat(cityObj.name, " is now given to empire ").concat(this.name));
        var isFirstCity = this._ownedCityNums.length <= 0;
        this._ownedCityNums.push(cityObj.num);
        if (isFirstCity) {
            this.home = cityObj;
        }
    };
    Object.defineProperty(Empire.prototype, "capitalKey", {
        get: function () {
            if (!globalThis.FACTIONS) {
                return;
            }
            return globalThis.FACTIONS.getEmpireCapitalKey(this.key);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Empire.prototype, "capitalCity", {
        get: function () {
            if (globalThis.CITIES && this.capitalKey) {
                return globalThis.CITIES.getByKey(this.capitalKey);
            }
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Empire.prototype, "isDefault", {
        /* == EMPIRE FLAGS == */
        get: function () {
            return this.key && this.key.length == 3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Empire.prototype, "isIndie", {
        get: function () {
            var indieKeys = ["I", "_I"];
            return indieKeys.includes(this.key);
        },
        enumerable: false,
        configurable: true
    });
    return Empire;
}(AbstractFaction));
export { Empire };
//# sourceMappingURL=empire.js.map