var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { Loggable } from "../../../common/log";
import { ColorPalette } from "../../../helpers/colorpalette";
import { RandomElement } from "../../../helpers/random";
var FactionFlag = /** @class */ (function (_super) {
    __extends(FactionFlag, _super);
    function FactionFlag(parentFaction, overwriteFlagStr) {
        var _this = _super.call(this, "FactionFlag") || this;
        _this.autoGenerate = true;
        // parent
        _this.faction = null;
        // flags
        _this.hasFlagStrOverride = false;
        if (parentFaction) {
            _this.faction = parentFaction;
            _this.strData = parentFaction.flagData;
        }
        // set str data
        if (overwriteFlagStr) {
            _this.hasFlagStrOverride = true;
            _this.strData = overwriteFlagStr;
        }
        _this.loadOrGenerate();
        return _this;
    }
    FactionFlag.prototype.loadOrGenerate = function () {
        if (!this.strData) {
            this.generate();
        }
        else {
            this.load();
        }
    };
    FactionFlag.prototype.generate = function () {
        this.iconColorName = ColorPalette.RandomColorName();
        this.bgColorName = ColorPalette.RandomColorName();
        this.iconName = RandomElement.of(FLAG_ICONS);
    };
    FactionFlag.prototype.load = function () {
        var splitted = this.strData.split(" ");
        if (splitted.length < 4) {
            this.error("cant load flag from str: ".concat(this.strData));
            return;
        }
        this.iconColorName = splitted[0].toUpperCase();
        this.iconName = splitted[1].toUpperCase();
        this.bgColorName = splitted[3].toUpperCase();
    };
    Object.defineProperty(FactionFlag.prototype, "factionKey", {
        /* FACTION FLAG GETTERS */
        get: function () {
            if (this.faction) {
                return this.faction.key;
            }
            return "U";
        },
        enumerable: false,
        configurable: true
    });
    return FactionFlag;
}(Loggable));
export { FactionFlag };
export var FLAG_ICONS = ["axes", "bird", "circle", "crescent", "cross", "cup", "flower", "horse",
    "lion", "none", "ship", "swords", "tower", "trident"];
//# sourceMappingURL=faction-flag.js.map