var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { AbstractFaction } from "./faction";
// helpers
import { RandomElement } from "../../../helpers/random";
import { FACTION_TYPES, TYPE_FAMILY } from "./faction-type";
/* == FAMILY MODEL == */
var Family = /** @class */ (function (_super) {
    __extends(Family, _super);
    function Family(name, home, isPlayer) {
        var _this = _super.call(this, null, name, home) || this;
        _this.units = [];
        _this.manorCityNums = [];
        // flags
        _this.hasRandomHome = false;
        _this.isAi = true;
        _this.factionType = FACTION_TYPES[TYPE_FAMILY];
        // optional
        if (!name) {
            _this.name = Family.randomName();
        }
        if (isPlayer) {
            _this.isAi = false;
        }
        return _this;
    }
    Family.prototype.setNum = function (familyNum) {
        this.num = familyNum;
        this.key = "F" + familyNum;
    };
    Family.prototype.setHome = function (city) {
        this._homeCity = city;
        // this.home = city;
        this.setRandomNameByHome();
    };
    /* RANDOM GENERATION */
    Family.randomName = function () {
        return RandomElement.of(Family.SURNAMES);
    };
    Family.prototype.setRandomNameByHome = function () {
        if (!this.homeCity) {
            return;
        }
        if (!globalThis.CHARS.hasNameListLoaded) {
            this.error("cant set random name from home; Char name list not found");
            return;
        }
        this.name = globalThis.CHARS.getRandomFamilyName(this.homeCity.language);
    };
    /* returns a new randomly generated Family with random name & home */
    Family.random = function () {
        var rndName = Family.randomName();
        var rndHome = globalThis.CITIES.getRandom();
        var family = new Family(rndName, rndHome);
        return family;
    };
    Family.prototype.buildManorIn = function (city) {
        this.manorCityNums.push(city.num);
    };
    Object.defineProperty(Family.prototype, "homeCity", {
        /* GETTERS */
        get: function () {
            if (this._homeCity) {
                return this._homeCity;
            }
            else if (this._homeCityKey && globalThis.CITIES) {
                return globalThis.CITIES.getByKey(this._homeCityKey);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Family, "PREFIX", {
        /* CONSTANTS */
        get: function () { return "House"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Family, "SURNAMES", {
        get: function () {
            return ["Valecci", "Du Chapel", "Fugger", "Habsburg", "Rurik", "Qing", "of Cornwall", "Di Bordia"];
        },
        enumerable: false,
        configurable: true
    });
    /* LOG */
    Family.prototype.toString = function () {
        return "<Family ".concat(this.num, " \"").concat(this.name, "\">");
    };
    return Family;
}(AbstractFaction));
export { Family };
/* == FAMILY CONSTANTS == */
//# sourceMappingURL=family.js.map