var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { WorldPos } from "../../world/pos";
/* == CONNECTION PATH MODEL == */
var AbstractConnectionPath = /** @class */ (function () {
    function AbstractConnectionPath(parent, start, target) {
        this.path = [];
        this.parent = parent;
        this.start = start;
        this.target = target;
    }
    AbstractConnectionPath.prototype.setDirectPath = function () {
        // add start pos
        this.addNextPos(this.start, true);
        var length = 0;
        var notAtTarget = !this.isAtTarget();
        while (!this.isAtTarget()) {
            var nextPos = this.getNextPos();
            this.addNextPos(nextPos, true);
            length += 1;
        }
    };
    /* adds WorldPosition into array of positions to target */
    AbstractConnectionPath.prototype.addNextPos = function (pos, addToTile) {
        this.path.push(pos);
        if (addToTile == true) {
            var tile = globalThis.MAP.tileAtPos(pos);
            tile.connections.push(this.parent);
        }
    };
    /* finds next WorldPos towards target */
    AbstractConnectionPath.prototype.getNextPos = function () {
        var lastPos = this.getLastPos();
        var relDist = [this.target.x - lastPos.x, this.target.z - lastPos.z];
        // get relative position towards next position (example: [-1, 0] = one to the west)
        var relXZ = [relDist[0] / Math.abs(relDist[0]), relDist[1] / Math.abs(relDist[1])];
        // start from absolute pos ..
        var absX = lastPos.x;
        var absZ = lastPos.z;
        // .. and move horizontally ..
        if (relXZ[0]) {
            absX = lastPos.x + relXZ[0];
        }
        // .. or vertically
        if (relXZ[1]) {
            absZ = lastPos.z + relXZ[1];
        }
        return new WorldPos(absX, absZ);
    };
    AbstractConnectionPath.prototype.getLastPos = function () {
        return this.path[this.path.length - 1];
    };
    AbstractConnectionPath.prototype.isAtTarget = function () {
        var lastPos = this.getLastPos();
        var isAtTarget = (lastPos.x == this.target.x) && (lastPos.z == this.target.z);
        return isAtTarget;
    };
    return AbstractConnectionPath;
}());
export { AbstractConnectionPath };
/* == CITY CONN PATH MODEL == */
var LocationConnectionPath = /** @class */ (function (_super) {
    __extends(LocationConnectionPath, _super);
    function LocationConnectionPath(parent, startLocation, targetLocation) {
        var _this = _super.call(this, parent, startLocation.pos, targetLocation.pos) || this;
        _this.path = [];
        _this.startLocation = startLocation;
        _this.targetLocation = targetLocation;
        return _this;
    }
    return LocationConnectionPath;
}(AbstractConnectionPath));
export { LocationConnectionPath };
//# sourceMappingURL=connection-path.js.map