// common
import { DawnbringerPalette } from "../../../common/colors";
// models
import { TradeResource } from "./resource";
var ResourceTypes = /** @class */ (function () {
    function ResourceTypes() {
        this._resourceIds = [];
        this.resources = [];
        // 1-9
        this.add(new TradeResource("ore", "Ores", DawnbringerPalette.LOULOU, 25, null, "mine", "M H"));
        this.add(new TradeResource("gold", "Gold", DawnbringerPalette.GOLDENFIZZ, 80, null, "mine", "M"));
        this.add(new TradeResource("gems", "Gems", DawnbringerPalette.BROWN, 240, null, "mine", "M"));
        this.add(new TradeResource("pottery", "Pottery", DawnbringerPalette.TAHITIGOLD, 60, ["stone"], "maker", "W", "guildhall"));
        this.add(new TradeResource("paper", "Paper", DawnbringerPalette.WHITE, 66, ["wood"], "maker", "G H", "church"));
        this.add(new TradeResource("pearls", "Pearls", DawnbringerPalette.VENICEBLUE, 80, null, "farm", "W"));
        this.add(new TradeResource("ivory", "Ivory", DawnbringerPalette.WHITE, 75, null, "camp", "S", "market"));
        this.add(new TradeResource("pelts", "Pelts", DawnbringerPalette.VERDIGRIS, 65, null, "camp", "H F"));
        this.add(new TradeResource("spices", "Spices", DawnbringerPalette.CHRISTI, 45, null, "farm", "D"));
        // 9-19
        this.add(new TradeResource("wool", "Wool", DawnbringerPalette.LIGHTSTEEL, 18, null, "farm", "H G"));
        this.add(new TradeResource("wood", "Wood", DawnbringerPalette.OILEDCEDAR, 14, null, "camp", "F"));
        this.add(new TradeResource("ale", "Ale", DawnbringerPalette.ROPE, 40, ["grain"], "house", "G H"));
        this.add(new TradeResource("clothes", "Clothes", DawnbringerPalette.DELL, 80, ["wool"], "farm", "H"));
        this.add(new TradeResource("silk", "Silk", DawnbringerPalette.LIGHTSTEEL, 120, null, "farm", "S"));
        this.add(new TradeResource("glass", "Glass", DawnbringerPalette.DEEPKOAMARU, 95, ["stone", "tools"]));
        this.add(new TradeResource("tools", "Tools", DawnbringerPalette.DIMGRAY, 65, ["ore"], "forge", null, "guildhall"));
        this.add(new TradeResource("grain", "Grain", DawnbringerPalette.GOLDENFIZZ, 22, null, "farm", "G S"));
        this.add(new TradeResource("fish", "Fish", DawnbringerPalette.ROYALBLUE, 26, null, "docks", "W"));
        this.add(new TradeResource("weapons", "Weapons", DawnbringerPalette.HEATHER, 135, ["ore", "tools"], "smith", "guildhall"));
        // special
        this.add(new TradeResource("special1", "X1", DawnbringerPalette.ROYALBLUE, 100));
        this.add(new TradeResource("special2", "X2", DawnbringerPalette.RAINFOREST, 100));
        this.add(new TradeResource("special3", "X3", DawnbringerPalette.CLAIRVOYANT, 100));
    }
    ResourceTypes.prototype.add = function (resource) {
        this._resourceIds.push(resource.id);
        this.resources.push(resource);
    };
    ResourceTypes.prototype.get = function (resId) {
        var resIndex = this._resourceIds.indexOf(resId);
        return this.resources[resIndex];
    };
    ResourceTypes.prototype.getIds = function () {
        return this._resourceIds;
    };
    ResourceTypes.prototype.getAll = function () {
        return this.resources;
    };
    ResourceTypes.prototype.setResource = function (resId, resObj) {
        var resIndex = this._resourceIds.indexOf(resId);
        this.resources[resIndex] = resObj;
    };
    return ResourceTypes;
}());
export { ResourceTypes };
//# sourceMappingURL=resource-types.js.map