var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { BaseEvent } from "../common/events";
/* == GAME LOADING == */
var EventManagerStartedEvent = /** @class */ (function (_super) {
    __extends(EventManagerStartedEvent, _super);
    function EventManagerStartedEvent() {
        return _super.call(this, ID_EVENTS_STARTED) || this;
    }
    return EventManagerStartedEvent;
}(BaseEvent));
export { EventManagerStartedEvent };
var AssetsLoadedEvent = /** @class */ (function (_super) {
    __extends(AssetsLoadedEvent, _super);
    function AssetsLoadedEvent(assetsLoaded) {
        var _this = _super.call(this, ID_ASSETS_LOADED) || this;
        _this.properties.addInteger("count", assetsLoaded);
        return _this;
    }
    return AssetsLoadedEvent;
}(BaseEvent));
export { AssetsLoadedEvent };
var MapFileLoadedEvent = /** @class */ (function (_super) {
    __extends(MapFileLoadedEvent, _super);
    function MapFileLoadedEvent(mapName) {
        var _this = _super.call(this, ID_MAP_LOADED) || this;
        _this.properties.addString("name", mapName);
        return _this;
    }
    return MapFileLoadedEvent;
}(BaseEvent));
export { MapFileLoadedEvent };
var UnitMountsAndGearLoadedEvent = /** @class */ (function (_super) {
    __extends(UnitMountsAndGearLoadedEvent, _super);
    function UnitMountsAndGearLoadedEvent(totalCount) {
        var _this = _super.call(this, ID_MOUNTS_GEAR_LOADED) || this;
        _this.properties.addInteger("total", totalCount);
        return _this;
    }
    return UnitMountsAndGearLoadedEvent;
}(BaseEvent));
export { UnitMountsAndGearLoadedEvent };
var UnitTypesInitializedEvent = /** @class */ (function (_super) {
    __extends(UnitTypesInitializedEvent, _super);
    function UnitTypesInitializedEvent(unitTypesCount) {
        var _this = _super.call(this, ID_UNIT_TYPES_INITIALIZED) || this;
        _this.properties.addInteger("count", unitTypesCount);
        return _this;
    }
    return UnitTypesInitializedEvent;
}(BaseEvent));
export { UnitTypesInitializedEvent };
var CityListLoadedEvent = /** @class */ (function (_super) {
    __extends(CityListLoadedEvent, _super);
    function CityListLoadedEvent(citiesCount) {
        var _this = _super.call(this, ID_CITY_LIST_LOADED) || this;
        _this.properties.addInteger("count", citiesCount);
        return _this;
    }
    return CityListLoadedEvent;
}(BaseEvent));
export { CityListLoadedEvent };
var CitiesPlacedEvent = /** @class */ (function (_super) {
    __extends(CitiesPlacedEvent, _super);
    function CitiesPlacedEvent(citiesCount) {
        var _this = _super.call(this, ID_CITIES_PLACED) || this;
        _this.properties.addInteger("count", citiesCount);
        return _this;
    }
    return CitiesPlacedEvent;
}(BaseEvent));
export { CitiesPlacedEvent };
/* == FILES == */
var OnJsonFileLoadedEvent = /** @class */ (function (_super) {
    __extends(OnJsonFileLoadedEvent, _super);
    function OnJsonFileLoadedEvent(shortPath, fullPath, content) {
        var _this = _super.call(this, ID_FILE_JSON_LOADED) || this;
        _this.properties.addString("shortPath", shortPath);
        _this.properties.addString("fullPath", fullPath);
        // add keys as str array
        var jsonKeys = Object.keys(content);
        _this.properties.addStrArray("keys", jsonKeys);
        return _this;
    }
    return OnJsonFileLoadedEvent;
}(BaseEvent));
export { OnJsonFileLoadedEvent };
var FileLoadingErrorEvent = /** @class */ (function (_super) {
    __extends(FileLoadingErrorEvent, _super);
    function FileLoadingErrorEvent(fullPath) {
        var _this = _super.call(this, ID_LOADING_ERROR) || this;
        _this.properties.addString("fullPath", fullPath);
        return _this;
    }
    return FileLoadingErrorEvent;
}(BaseEvent));
export { FileLoadingErrorEvent };
/* == TURN == */
var BeforeTurnStartedEvent = /** @class */ (function (_super) {
    __extends(BeforeTurnStartedEvent, _super);
    function BeforeTurnStartedEvent(turnNum) {
        var _this = _super.call(this, ID_TURN_BEFORE_STARTED) || this;
        _this.properties.addInteger("num", turnNum);
        return _this;
    }
    return BeforeTurnStartedEvent;
}(BaseEvent));
export { BeforeTurnStartedEvent };
var TurnStartedEvent = /** @class */ (function (_super) {
    __extends(TurnStartedEvent, _super);
    function TurnStartedEvent(turnNum) {
        var _this = _super.call(this, ID_TURN_STARTED) || this;
        _this.properties.addInteger("num", turnNum);
        return _this;
    }
    TurnStartedEvent.prototype.toString = function () { return "<TurnStarted ".concat(this.properties.getNum("num")); };
    return TurnStartedEvent;
}(BaseEvent));
export { TurnStartedEvent };
var PlayerTurnFinishedEvent = /** @class */ (function (_super) {
    __extends(PlayerTurnFinishedEvent, _super);
    function PlayerTurnFinishedEvent(turnNum) {
        var _this = _super.call(this, ID_TURN_FINISHED) || this;
        _this.properties.addInteger("num", turnNum);
        return _this;
    }
    return PlayerTurnFinishedEvent;
}(BaseEvent));
export { PlayerTurnFinishedEvent };
/* == PLAYER == */
var PlayerMovedEvent = /** @class */ (function (_super) {
    __extends(PlayerMovedEvent, _super);
    function PlayerMovedEvent(targetPos, directionStr, sourcePos) {
        var _this = _super.call(this, ID_PLAYER_MOVED) || this;
        _this.properties.addWorldPos("target", targetPos);
        _this.properties.addString("dirStr", directionStr);
        if (sourcePos) {
            _this.properties.addWorldPos("sourcePos", sourcePos);
        }
        return _this;
    }
    return PlayerMovedEvent;
}(BaseEvent));
export { PlayerMovedEvent };
/* == UNIT & ARMY == */
var ArmySpawnedEvent = /** @class */ (function (_super) {
    __extends(ArmySpawnedEvent, _super);
    function ArmySpawnedEvent(armyNum, armyType, pos, parentNum) {
        var _this = _super.call(this, ID_ARMY_SPAWNED) || this;
        _this.properties.addInteger("num", armyNum);
        _this.properties.addInteger("armyType", armyType);
        _this.properties.addWorldPos("pos", pos);
        _this.properties.addInteger("parentNum", parentNum);
        // before game start?
        _this.properties.addBoolean("beforeStart", !globalThis.GAME_HAS_STARTED);
        return _this;
    }
    return ArmySpawnedEvent;
}(BaseEvent));
export { ArmySpawnedEvent };
/* == CITY == */
var CityEnteredEvent = /** @class */ (function (_super) {
    __extends(CityEnteredEvent, _super);
    function CityEnteredEvent(city) {
        var _this = _super.call(this, ID_CITY_ENTERED) || this;
        _this.properties.addInteger("num", city.num);
        _this.properties.addString("name", city.name);
        return _this;
    }
    return CityEnteredEvent;
}(BaseEvent));
export { CityEnteredEvent };
var CityResourceTradeRequest = /** @class */ (function (_super) {
    __extends(CityResourceTradeRequest, _super);
    function CityResourceTradeRequest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return CityResourceTradeRequest;
}(BaseEvent));
export { CityResourceTradeRequest };
var ConstructionFinishedEvent = /** @class */ (function (_super) {
    __extends(ConstructionFinishedEvent, _super);
    function ConstructionFinishedEvent(location, bldId, bldLevel) {
        var _this = _super.call(this, ID_CONSTR_FINISHED) || this;
        _this.properties.addInteger("locationNum", location.num);
        _this.properties.addString("bldId", bldId);
        _this.properties.addInteger("bldLevel", bldLevel);
        return _this;
    }
    return ConstructionFinishedEvent;
}(BaseEvent));
export { ConstructionFinishedEvent };
var CityPopulationIncreasedEvent = /** @class */ (function (_super) {
    __extends(CityPopulationIncreasedEvent, _super);
    function CityPopulationIncreasedEvent(city, popClassNum, newPopulation) {
        var _this = _super.call(this, ID_POP_INCREASED) || this;
        _this.properties.addInteger("cityNum", city.num);
        _this.properties.addInteger("popClass", popClassNum);
        _this.properties.addInteger("population", newPopulation);
        return _this;
    }
    return CityPopulationIncreasedEvent;
}(BaseEvent));
export { CityPopulationIncreasedEvent };
/* == TRADING == */
var CityDeliveryMadeEvent = /** @class */ (function (_super) {
    __extends(CityDeliveryMadeEvent, _super);
    function CityDeliveryMadeEvent(sourceCity, targetCity, resId, resAmount, profit) {
        var _this = _super.call(this, ID_TRADE_DELIVERY_MADE) || this;
        _this.properties.addInteger("sourceCityNum", sourceCity.num);
        _this.properties.addInteger("targetCityNum", targetCity.num);
        _this.properties.addString("resource", resId);
        _this.properties.addInteger("amount", resAmount);
        _this.properties.addInteger("profit", profit);
        return _this;
    }
    return CityDeliveryMadeEvent;
}(BaseEvent));
export { CityDeliveryMadeEvent };
var PlayerTradedEvent = /** @class */ (function (_super) {
    __extends(PlayerTradedEvent, _super);
    function PlayerTradedEvent(city, hasSold, resId, resAmount, profit, cityPrice) {
        var _this = _super.call(this, ID_TRADE_PLAYER) || this;
        _this.properties.addInteger("cityNum", city.num);
        _this.properties.addBoolean("hasSold", hasSold);
        _this.properties.addString("resource", resId);
        _this.properties.addInteger("amount", resAmount);
        _this.properties.addInteger("profit", profit);
        _this.properties.addInteger("price", cityPrice);
        return _this;
    }
    return PlayerTradedEvent;
}(BaseEvent));
export { PlayerTradedEvent };
/* == GUI == */
var GuiElementClickedEvent = /** @class */ (function (_super) {
    __extends(GuiElementClickedEvent, _super);
    function GuiElementClickedEvent(elemId, isButton) {
        var _this = _super.call(this, ID_GUI_ELEM_CLICKED) || this;
        _this.properties.addString("elemId", elemId);
        if (isButton) {
            _this.properties.addBoolean("button", true);
        }
        return _this;
    }
    return GuiElementClickedEvent;
}(BaseEvent));
export { GuiElementClickedEvent };
var GuiMenuUpdateRequest = /** @class */ (function (_super) {
    __extends(GuiMenuUpdateRequest, _super);
    function GuiMenuUpdateRequest(elemId, partialUpdateData) {
        var _this = _super.call(this, ID_GUI_MENU_UPDATE) || this;
        _this.properties.addString("elemId", elemId);
        if (partialUpdateData) {
            _this.properties.addString("partialUpdateData", partialUpdateData);
        }
        return _this;
    }
    return GuiMenuUpdateRequest;
}(BaseEvent));
export { GuiMenuUpdateRequest };
// please add in correct order
// loading
export var ID_EVENTS_STARTED = "EventManagerStarted";
export var ID_ASSETS_LOADED = "AssetsLoaded";
export var ID_MOUNTS_GEAR_LOADED = "UnitMountAndGearLoaded";
export var ID_UNIT_TYPES_INITIALIZED = "UnitTypesInitialized";
export var ID_MAP_LOADED = "MapFileLoaded";
export var ID_CITY_LIST_LOADED = "CityListLoaded";
export var ID_CITIES_PLACED = "CitiesPlaced";
// files
export var ID_FILE_JSON_LOADED = "JsonFileLoaded";
export var ID_LOADING_ERROR = "FileLoadingError";
// turns
export var ID_TURN_BEFORE_STARTED = "BeforeTurnStarted";
export var ID_TURN_STARTED = "TurnStarted";
export var ID_TURN_FINISHED = "TurnFinished";
// player
export var ID_PLAYER_MOVED = "PlayerMoved";
// units
export var ID_ARMY_SPAWNED = "ArmyCreated";
// city
export var ID_CITY_ENTERED = "CityEntered";
export var ID_CONSTR_FINISHED = "ConstructionFinished";
export var ID_POP_INCREASED = "PopulationIncreased";
// trade
export var ID_TRADE_DELIVERY_MADE = "CityDelivery";
export var ID_TRADE_PLAYER = "PlayerTrade";
// gui
export var ID_GUI_ELEM_CLICKED = "GuiElementClicked";
export var ID_GUI_MENU_UPDATE = "GuiMenuUpdateRequest;";
export var ID_GUI_DIAG_SHOW_REQUEST = "GuiDiagShow";
export var ID_GUI_DIAG_CLOSE_REQUEST = "GuiDiagClose";
//# sourceMappingURL=game-events.js.map