var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Properties } from "../common/properties";
import { WorldPos } from "./world/pos";
var GameOptions = /** @class */ (function (_super) {
    __extends(GameOptions, _super);
    function GameOptions() {
        var _this = _super.call(this) || this;
        _this.loadDefaultGameOptions();
        return _this;
    }
    GameOptions.prototype.loadDefaultGameOptions = function () {
        console.log("<GameOptions> loading default options ..");
        // map options
        this.addWorldPos(GameOptions.START_POS, new WorldPos(100, 100));
        this.addInteger(GameOptions.MAP_VIEW_DISTANCE, 60);
        // map generation
        this.addBoolean(GameOptions.GENERATE_LANDSCAPE, false);
        this.addBoolean(GameOptions.GENERATE_LOCATIONS, false);
        this.addInteger(GameOptions.MAP_MAXCITIES, 30);
        // players
        this.addInteger(GameOptions.AI_FAMILIES, 5);
        console.log("<GameOptions> ".concat(this.props.length, " options loaded"));
    };
    Object.defineProperty(GameOptions, "GENERATE_LANDSCAPE", {
        /* OPTION KEYS */
        // Map
        get: function () { return "generate-map"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GameOptions, "GENERATE_LOCATIONS", {
        get: function () { return "generate-locations"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GameOptions, "MAP_MAXCITIES", {
        get: function () { return "max-cities"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GameOptions, "MAP_VIEW_DISTANCE", {
        get: function () { return "view-distance"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GameOptions, "START_POS", {
        // Players
        get: function () { return "start-pos"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GameOptions, "AI_FAMILIES", {
        get: function () { return "max-families"; },
        enumerable: false,
        configurable: true
    });
    return GameOptions;
}(Properties));
export { GameOptions };
//# sourceMappingURL=game-options.js.map