var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { BaseEventListener } from "../../../common/events";
// events
// models
import { Size } from "../../world/pos";
/* ABSTRACT CLASSES */
var AbstractGuiElement = /** @class */ (function (_super) {
    __extends(AbstractGuiElement, _super);
    function AbstractGuiElement(id, parent) {
        var _this = _super.call(this, "GuiElem") || this;
        _this.size = new Size(0, 0);
        _this.isActive = true;
        // childs & parent
        _this.parent = null;
        _this.babylon = null;
        _this.id = id;
        // add to parent
        if (parent) {
            parent.add(_this);
            _this.parent = parent;
        }
        return _this;
    }
    AbstractGuiElement.prototype.init = function () {
        this.error("cant build AbstractGuiElement; have you forgotten to implement build()?");
    };
    AbstractGuiElement.prototype.build = function () {
        this.error("cant show AbstractGuiElement; have you forgotten to implement show()?");
        return null;
    };
    AbstractGuiElement.prototype.dispose = function () {
        if (!this.babylon) {
            return;
        }
        this.isActive = false;
        this.babylon.dispose();
    };
    /* LOG */
    AbstractGuiElement.prototype.toString = function () {
        return "<GuiEl \"".concat(this.id, "\">");
    };
    return AbstractGuiElement;
}(BaseEventListener));
export { AbstractGuiElement };
/* STYLE TYPES */
var StyleBackground = /** @class */ (function () {
    function StyleBackground() {
    }
    Object.defineProperty(StyleBackground, "TRANSPARENT", {
        get: function () { return 0; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StyleBackground, "PAPER", {
        get: function () { return 1; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StyleBackground, "LEATHER", {
        get: function () { return 2; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StyleBackground, "ALL", {
        get: function () {
            return [
                StyleBackground.TRANSPARENT, StyleBackground.PAPER, StyleBackground.LEATHER
            ];
        },
        enumerable: false,
        configurable: true
    });
    return StyleBackground;
}());
export { StyleBackground };
var StyleBorder = /** @class */ (function () {
    function StyleBorder() {
    }
    Object.defineProperty(StyleBorder, "NONE", {
        get: function () { return null; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StyleBorder, "THIN_FRAME", {
        get: function () { return "frame-thin"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StyleBorder, "OUTTER_FRAME", {
        get: function () { return "frame-outter"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StyleBorder, "ALL", {
        get: function () {
            return [
                StyleBorder.NONE,
                StyleBorder.THIN_FRAME,
                StyleBorder.OUTTER_FRAME
            ];
        },
        enumerable: false,
        configurable: true
    });
    return StyleBorder;
}());
export { StyleBorder };
/* STYLED ELEMENTS */
var GuiStyle = /** @class */ (function () {
    function GuiStyle(bg, extra) {
        this.bg = StyleBackground.TRANSPARENT;
        this.extra = StyleBorder.NONE;
        // set optional properties
        if (bg) {
            this.bg = bg;
        }
        if (extra) {
            this.extra = extra;
        }
    }
    return GuiStyle;
}());
export { GuiStyle };
var StyledGuiElement = /** @class */ (function (_super) {
    __extends(StyledGuiElement, _super);
    function StyledGuiElement(id, parent, style) {
        var _this = _super.call(this, id, parent) || this;
        _this.style = new GuiStyle();
        _this.style = style;
        return _this;
    }
    return StyledGuiElement;
}(AbstractGuiElement));
export { StyledGuiElement };
//# sourceMappingURL=element.js.map