var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { BuildingCategory } from "../../entities/building/building-category";
// gui
import * as GUI_CONST from '../common/constants';
import { EmptyDialog } from "./common/base-dialog";
// babylon
import * as GUI from 'babylonjs-gui';
/* == CITY CONSTRUCTION DIALOG == */
var CityConstructionDialog = /** @class */ (function (_super) {
    __extends(CityConstructionDialog, _super);
    function CityConstructionDialog(city) {
        var _this = _super.call(this, DIAG_CONSTR, false, "".concat(city.name, " Construction")) || this;
        _this.city = city;
        return _this;
    }
    CityConstructionDialog.prototype.addCustomContent = function () {
        var switcherOptionStrs = DIAG_CONSTR_SWITCHER_OPTIONS_NAMES;
        this.addNewSwitcher(DIAG_CONSTR_SWITCHER, switcherOptionStrs);
        // inner layout
        this.createInnerLayout();
        // switcher
        var startOption = DIAG_CONSTR_SWITCHER_OPTIONS_NAMES[0];
        this.onSwitcherChange(DIAG_CONSTR_SWITCHER, startOption);
    };
    CityConstructionDialog.prototype.createInnerLayout = function () {
        // create scrollable outter container
        this.scrollViewer = new GUI.ScrollViewer(DIAG_CONSTR_CONTENT_OUTTER);
        this.scrollViewer.widthInPixels = 400;
        this.scrollViewer.heightInPixels = DIAG_CONSTR_CONTENT_HEIGHT_PX;
        // GuiScrollView.setDefaultStyle(this.scrollViewer, true); 
        // and stackpanel inside it
        this.innerLayout = new GUI.StackPanel(DIAG_CONSTR_CONTENT);
        this.innerLayout.heightInPixels = DIAG_CONSTR_CONTENT_HEIGHT_PX;
        var innerLayoutBgImg = new GUI.Image(DIAG_CONSTR_CONTENT_OUTTER + "img", GUI_CONST.BG_PAPER);
        innerLayoutBgImg.heightInPixels = DIAG_CONSTR_CONTENT_HEIGHT_PX;
        // add bg and inner stackpanel to bld list layout
        this.scrollViewer.addControl(innerLayoutBgImg);
        this.scrollViewer.addControl(this.innerLayout);
        // add to constr dialog
        this.addControl(this.scrollViewer, true);
    };
    CityConstructionDialog.prototype.addConstructableList = function (bldCatNum, hideNonProducable) {
        var bldCatName = DIAG_CONSTR_SWITCHER_OPTIONS_NAMES[bldCatNum];
        this.log("showing constructable buildings of category: ".concat(bldCatNum, " \"").concat(bldCatName, "\""));
        var bldTypesOfCat = globalThis.CONSTRUCTABLE.getByCategory(bldCatNum);
        this.log("".concat(bldTypesOfCat.length, " building types in cat"));
        for (var _i = 0, bldTypesOfCat_1 = bldTypesOfCat; _i < bldTypesOfCat_1.length; _i++) {
            var bldType = bldTypesOfCat_1[_i];
            // when building is of production categoory & cities cant produce this resource
            var hideType = false;
            if (hideNonProducable == true && bldType.category.isProd) {
                hideType = this.prodBldTypeIsHidden(bldType.id);
            }
            // show if not hidden
            if (!hideType) {
                this.addConstructableItem(bldType);
            }
        }
    };
    CityConstructionDialog.prototype.prodBldTypeIsHidden = function (bldId) {
        var resId = bldId.replace('prod-', '');
        // const resId = ProductionBuildingType.ResFromTypeId(bldId).id;
        var canBuild = this.city.canProduce(resId);
        if (!canBuild) {
            this.log("building ".concat(bldId, " cant be build here; no neighboring ").concat(resId, " tiles"));
            return true;
        }
        return false;
    };
    CityConstructionDialog.prototype.addConstructableItem = function (bldType) {
        var elemId = "lbl-build-".concat(bldType.id);
        var constrRow = this.addNewDataRow(bldType.name, "Costs: 0", "building", true, elemId, this.innerLayout);
        constrRow.name = elemId;
    };
    CityConstructionDialog.prototype.onSwitcherChange = function (elemId, bldTypeNameStr) {
        _super.prototype.onSwitcherChange.call(this, elemId, bldTypeNameStr);
        if (elemId == DIAG_CONSTR_SWITCHER) {
            this.innerLayout.clearControls();
            var bldCatNameIndex = DIAG_CONSTR_SWITCHER_OPTIONS_NAMES.indexOf(bldTypeNameStr);
            var bldCatNum = DIAG_CONSTR_SWITCHER_OPTIONS_ID[bldCatNameIndex];
            this.addConstructableList(bldCatNum, true);
        }
    };
    return CityConstructionDialog;
}(EmptyDialog));
export { CityConstructionDialog };
/* == CONSTANTS == */
export var DIAG_CONSTR = "diag-constr";
export var DIAG_CONSTR_BTN_BUILD = DIAG_CONSTR + "-btn-build";
export var DIAG_CONSTR_SWITCHER = DIAG_CONSTR + "-bld-cat";
export var DIAG_CONSTR_SWITCHER_OPTIONS_NAMES = ["Civic", "Resources", "Military"];
export var DIAG_CONSTR_SWITCHER_OPTIONS_ID = [BuildingCategory.CIVIC, BuildingCategory.PROD, BuildingCategory.MIL];
export var DIAG_CONSTR_CONTENT = DIAG_CONSTR + "-content";
export var DIAG_CONSTR_CONTENT_OUTTER = DIAG_CONSTR_CONTENT + "-bg";
export var DIAG_CONSTR_CONTENT_HEIGHT_PX = 400;
export var DIAG_CONSTR_BLD_PREFIX = DIAG_CONSTR + "-bld-";
//# sourceMappingURL=city-construction-dialog.js.map