var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { POPS_UPDATE_GROWTH } from "../../entities/city/population";
// gui
import * as GUI_CONST from '../common/constants';
import { EmptyDialog } from "./common/base-dialog";
import { CityConsumptionDialog } from "./city-consumption-dialog";
/* == CITY POP DIALOG == */
/* opened on city population row click; shows the class composition and resource requirements of this city */
var CityPopulationDialog = /** @class */ (function (_super) {
    __extends(CityPopulationDialog, _super);
    function CityPopulationDialog(city) {
        var _this = _super.call(this, DIAG_POPULATION, false, "".concat(city.name, " Population")) || this;
        _this.population = null;
        _this.city = city;
        _this.population = city.population;
        return _this;
    }
    /* ADD CHILD ELEMENTS */
    CityPopulationDialog.prototype.addCustomContent = function () {
        // class pops
        this.addPopClassesList();
        // consumption
        var resDeliveredRowId = DIAG_POPULATION_ROW_CONSUMPTION_ID;
        var consumptionPercent = this.population.lastConsumptionSuccess * 100;
        var consumptionSuccessStr = "".concat(consumptionPercent.toFixed(1), "%");
        this.addNewDataRow("Delivered", consumptionSuccessStr, "happiness", true, resDeliveredRowId);
        // total growth
        var growthStr = this.city.growth.toFixed(1) + "/" + POPS_UPDATE_GROWTH;
        this.addNewDataRow("Growth", growthStr, "growth");
        // last turn taxes
        this.addNewDataRow("Taxes", "" + this.city.taxesLastTurn, "money");
        // show "Talk To Mayor" button
        this.addNewButton(DIAG_POPULATION_BTN_TALKTOMAYOR, "Talk To Mayor");
    };
    CityPopulationDialog.prototype.addPopClassesList = function () {
        for (var _i = 0, _a = this.population.classes; _i < _a.length; _i++) {
            var cityClass = _a[_i];
            this.addSinglePopClassRow(cityClass);
        }
        ;
        // add divider after pop class list
        this.addNewDivider();
    };
    CityPopulationDialog.prototype.addSinglePopClassRow = function (cityClass) {
        var classIcon = cityClass.iconName;
        var classPopsAmount = this.population.getAmount(cityClass.level);
        this.addNewDataRow(cityClass.name, "".concat(classPopsAmount), classIcon);
    };
    /* EVENT HANDLING */
    CityPopulationDialog.prototype.onEvent = function (ev) {
        _super.prototype.onEvent.call(this, ev);
    };
    CityPopulationDialog.prototype.onElementClicked = function (elemId) {
        var success = _super.prototype.onElementClicked.call(this, elemId);
        var city = this.city;
        if (elemId.startsWith(GUI_CONST.ELEM_PREFIX_DATAROW)) {
            var datarowKey = elemId.replace(GUI_CONST.ELEM_PREFIX_DATAROW, "");
            if (datarowKey.startsWith("Delivered")) {
                var consumptionDiag = new CityConsumptionDialog(city);
                globalThis.GUI.showDialog(consumptionDiag);
                return true;
            }
        }
        return false;
    };
    return CityPopulationDialog;
}(EmptyDialog));
export { CityPopulationDialog };
/* == CONSTANTS == */
export var DIAG_POPULATION = "diag-population";
export var DIAG_POPULATION_ROW_CONSUMPTION_ID = DIAG_POPULATION + "-datarow-Delivered";
export var DIAG_POPULATION_BTN_TALKTOMAYOR = DIAG_POPULATION + "-btn-talktomayor";
//# sourceMappingURL=city-population-dialog.js.map