var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as EV from "../../../game-events";
// gui
import * as GUI_CONST from '../../common/constants';
import { FlexGuiLayout } from '../../common/layouts';
import { DialogButton } from './dialog-button';
// gui
import * as GUI_EV from "../../common/gui-events";
import { GuiRectangle } from '../../common/rectangle';
import { FactionFlagImage } from "../../elements/babylon/flags";
import { GuiScrollView } from "../../elements/scroller";
/* == EMPTY DIALOG == */
var EmptyDialog = /** @class */ (function (_super) {
    __extends(EmptyDialog, _super);
    function EmptyDialog(id, isBlocking, headerText, extraButtons, customBackground, noButtonDivider, showFactionFlag) {
        var _this = _super.call(this, id, GUI_CONST.DIR_VERT, headerText) || this;
        _this.titleText = "Unnamed Dialog";
        // flags
        _this.hasCustomBackground = false;
        _this.showFactionFlag = null;
        _this.buttonIds = ["cancel", "ok"];
        _this.noButtonDivider = false;
        _this.isBlocking = isBlocking;
        // optionals
        if (customBackground) {
            _this.hasCustomBackground = true;
        }
        if (noButtonDivider) {
            _this.noButtonDivider = true;
        }
        if (showFactionFlag) {
            _this.showFactionFlag = showFactionFlag;
        }
        // add buttons
        _this.addButtons(extraButtons);
        return _this;
    }
    EmptyDialog.prototype.switchToDialog = function (dialog) {
        this.close();
        globalThis.GUI.showDialog(dialog, true);
    };
    EmptyDialog.prototype.build = function () {
        // build FlexGuiLayout & set style & sizing
        _super.prototype.build.call(this, false);
        this.outter.height = "70%";
        GuiScrollView.setDefaultStyle(this.outter);
        // build optional children: background image & faction flag
        if (this.hasCustomBackground) {
            this.buildBackground();
        }
        if (this.showFactionFlag) {
            this.addFactionFlag();
        }
        // build button bar
        this.buildButtonBar();
    };
    EmptyDialog.prototype.addFactionFlag = function () {
        var factionFlag = this.showFactionFlag.flag;
        if (factionFlag) {
            var flag = new FactionFlagImage(factionFlag);
            flag.left = "-20px";
            this.outter.addControl(flag);
        }
    };
    EmptyDialog.prototype.addButtons = function (newButtonIds) {
        this.buttonIds = this.buttonIds.concat(newButtonIds);
    };
    EmptyDialog.prototype.addNewDivider = function (empty, setParent) {
        var divider = _super.prototype.addNewDivider.call(this, empty, setParent);
        divider.widthInPixels = 400;
        return divider;
    };
    EmptyDialog.prototype.buildBackground = function () {
        var outterElemId = "".concat(this.id, "-inner");
        this.inner = new GuiRectangle(outterElemId);
        this.inner.width = GUI_CONST.DIALOG_OUTTER_WIDTH;
        this.inner.height = GUI_CONST.DIALOG_HEIGHT;
        this.addControl(this.inner);
    };
    EmptyDialog.prototype.buildButtonBar = function () {
        if (!this.noButtonDivider) {
            this.addNewDivider(true);
        }
        // add close button
        this.addNewButton(ID_BUTTON_CLOSE, "Close");
    };
    EmptyDialog.prototype.close = function () {
        this.log("closing ..");
        this.outter.dispose();
        this.babylon.dispose();
        globalThis.DIALOG = null;
    };
    EmptyDialog.prototype.onButtonClick = function (btnId) {
        this.log("button ".concat(btnId, " clicked"));
        globalThis.EVENTS.fireEvent(new EV.GuiElementClickedEvent(btnId, true));
        if (btnId == ID_BUTTON_CLOSE) {
            this.close();
        }
    };
    EmptyDialog.prototype.onSwitcherChange = function (elemId, selected) {
        this.log("switcher \"".concat(elemId, "\" changed to ").concat(selected));
    };
    EmptyDialog.prototype.addNewButton = function (btnId, text) {
        return DialogButton.CreateNew(btnId, text, this);
    };
    EmptyDialog.prototype.onEvent = function (ev) {
        _super.prototype.onEvent.call(this, ev);
        if (ev.id == GUI_EV.ID_SWITCHER_CHANGE) {
            var elemId = ev.properties.getStr("elemId");
            var selected = ev.properties.getStr("selected");
            this.onSwitcherChange(elemId, selected);
        }
    };
    /* TO STRING */
    EmptyDialog.prototype.toString = function () {
        var directChildCount = this.children.length;
        return "<Dialog id=\"".concat(this.id, "\" title=\"").concat(this.title, "\" children=").concat(directChildCount, ">");
    };
    return EmptyDialog;
}(FlexGuiLayout));
export { EmptyDialog };
/* == SPECIAL DIALOG: INFO == */
/* == DIALOG DEFAULT CONSTANTS == */
export var ID_BUTTON_CLOSE = "diag-close";
export var BUTTON_TEXT_COLOR = "ATLANTIS";
/* == SPECIAL DIALOGS CONSTANTS == */ 
//# sourceMappingURL=base-dialog.js.map