var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EmptyDialog } from "./common/base-dialog";
import { CityTransferDialog } from "./city-transfer-dialog";
import { GuiScrollView } from "../elements/scroller";
// babylon
import * as GUI from 'babylonjs-gui';
import { CityTradeHistoryDialog } from "./city-tradehist-dialog";
import { GuiCheckBox } from "../elements/checkbox";
/* == RES LIST DIALOG == */
var ResourceListDialog = /** @class */ (function (_super) {
    __extends(ResourceListDialog, _super);
    function ResourceListDialog(market) {
        var _this = _super.call(this, DIAG_RESLIST, true, "".concat(market.parentLocation.name, ": Market"), [DIAG_RESLIST_BTN_HISTORY_TEXT], null) || this;
        _this.showAll = false;
        // set TradeLocation of this dialog
        _this.location = market.parentLocation;
        return _this;
    }
    ResourceListDialog.prototype.build = function () { _super.prototype.build.call(this); };
    ResourceListDialog.prototype.addCustomContent = function () {
        this.addShowAllCheckbox();
        this.addResourceList();
        this.addNewButton(DIAG_RESLIST_BTN_HISTORY, DIAG_RESLIST_BTN_HISTORY_TEXT);
    };
    ResourceListDialog.prototype.addShowAllCheckbox = function () {
        this.showAllCheckbox = new GuiCheckBox(DIAG_RESLIST_CHECKB_SHOWALL, "Show All", this.showAll, false);
        this.addControl(this.showAllCheckbox, true);
    };
    ResourceListDialog.prototype.addResourceList = function () {
        // this.addScrollView();
        var storedResources = this.location.tradeNode.asStoredResources();
        for (var _i = 0, storedResources_1 = storedResources; _i < storedResources_1.length; _i++) {
            var storedRes = storedResources_1[_i];
            this.addResourceListElement(storedRes);
        }
    };
    ResourceListDialog.prototype.addScrollView = function () {
        this.scroller = new GUI.ScrollViewer(DIAG_RESLIST_SCROLLVIEW);
        GuiScrollView.setDefaultStyle(this.scroller);
        // sizing
        this.scroller.height = DIAG_RESLIST_INNER_HEIGHT;
        this.addInnerLayout();
        this.addControl(this.scroller, true);
        this.addNewDivider(true);
    };
    ResourceListDialog.prototype.addInnerLayout = function () {
        this.innerLayout = new GUI.StackPanel(DIAG_RESLIST_INNER);
        if (this.scroller) {
            this.scroller.addControl(this.innerLayout);
        }
        else {
            this.addControl(this.innerLayout);
        }
    };
    ResourceListDialog.prototype.addResourceListElement = function (storedRes) {
        var resName = globalThis.TRADE.getResName(storedRes.resId);
        var elemId = DIAG_RESLIST_LBL_PREFIX + storedRes.resId;
        var valueStr = ResourceListDialog.GetElementValueStr(storedRes);
        this.addNewDataRow(resName, valueStr, DIAG_RESLIST_STORAGE_ICON, true, elemId, this.innerLayout);
    };
    /* EVENT HANDLING */
    ResourceListDialog.prototype.onButtonClick = function (btnId) {
        _super.prototype.onButtonClick.call(this, btnId);
        if (btnId == DIAG_RESLIST_BTN_HISTORY) {
            this.switchToDialog(new CityTradeHistoryDialog(this.location));
        }
    };
    ResourceListDialog.prototype.onElementClicked = function (elemId) {
        var success = _super.prototype.onElementClicked.call(this, elemId);
        if (!success) {
            return false;
        }
        // datarow?
        if (elemId.startsWith(ID_REFIX_DATAROW)) {
            var resId = ResourceListDialog.GetResIdFromDataRowId(elemId);
            var cityTransferDiag = new CityTransferDialog(this.location, resId);
            this.switchToDialog(cityTransferDiag);
        }
        // showall checkbox?
        if (elemId.startsWith(DIAG_RESLIST_CHECKB_SHOWALL)) {
            this.showAll != this.showAll;
            this.log("showAll? ".concat(this.showAll));
            this.showAllCheckbox.isChecked = this.showAll;
            // this.showAllCheckbox.update();
        }
        return true;
    };
    /* STATIC GETTERS */
    ResourceListDialog.GetElementValueStr = function (storedRes) {
        var amountStr = "" + storedRes.amount.toFixed(1);
        var priceStr = "" + storedRes.price.toFixed(0) + "o";
        return amountStr + "  (" + priceStr + ")";
    };
    ResourceListDialog.GetResIdFromDataRowId = function (elemId) {
        if (!globalThis.TRADE) {
            console.warn("<DiagReslist> cant get resId from datarow \"".concat(elemId, "\"; TradeManager not found"));
            return;
        }
        // remove element prefix & postfix ("-key")
        var resName = elemId.replace(ID_REFIX_DATAROW, "").replace("-key", "");
        var tradeRes = globalThis.TRADE.getResByName(resName);
        if (!tradeRes) {
            console.warn("<ResListDiag> cant get trade resource with name \"".concat(resName, "\""));
            return;
        }
        return tradeRes.id;
    };
    return ResourceListDialog;
}(EmptyDialog));
export { ResourceListDialog };
/* == RESLIST DIAG CONSTANTS == */
export var DIAG_RESLIST = "diag-reslist";
export var DIAG_RESLIST_INNER_HEIGHT = "400px";
export var ID_REFIX_DATAROW = "datarow-";
// children
export var DIAG_RESLIST_CHECKB_SHOWALL = DIAG_RESLIST + "-showall";
export var DIAG_RESLIST_BTN_HISTORY = "btn-reslist-history";
export var DIAG_RESLIST_BTN_HISTORY_TEXT = "Trade History";
export var DIAG_RESLIST_LBL_PREFIX = "reslist-item-";
export var DIAG_RESLIST_STORAGE_ICON = "storage";
export var DIAG_RESLIST_SCROLLVIEW = "diag-reslist-scroll";
export var DIAG_RESLIST_INNER = "diag-reslist-inner";
//# sourceMappingURL=reslist-dialog.js.map