var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import * as GUI_CONST from '../../common/constants';
import * as GUI from 'babylonjs-gui';
import { GuiTools } from '../../common/gui-tools';
import { ColorPalette } from '../../../../helpers/colorpalette';
var FactionFlagImage = /** @class */ (function (_super) {
    __extends(FactionFlagImage, _super);
    function FactionFlagImage(factionFlag) {
        var _this = this;
        var flagImgId = "flag-" + factionFlag.factionKey;
        _this = _super.call(this, flagImgId) || this;
        // set properties
        _this.factionFlag = factionFlag;
        // adjust container & add children
        _this.adjustContainer();
        _this.addBackground();
        _this.addFlagIcon();
        return _this;
        // tinting?
    }
    FactionFlagImage.prototype.adjustContainer = function () {
        this.thickness = 0;
        GuiTools.setSizeInPx(this, SIZE_OUTTER_PX, SIZE_OUTTER_PX);
        // set padding
        this.paddingLeft = "24px";
        this.paddingRight = "12px";
        // set alignments
        var alignments = [GUI_CONST.ALIGN_H_RIGHT, GUI_CONST.ALIGN_V_TOP];
        GuiTools.setAlignments(this, alignments);
    };
    FactionFlagImage.prototype.addBackground = function () {
        var bgId = this.name + "-bg";
        this.bg = new GUI.Rectangle(bgId);
        this.bg.thickness = 0;
        // add to parent
        this.addControl(this.bg);
        // place in center
        var bgAlignments = [GUI_CONST.ALIGN_H_CENTER, GUI_CONST.ALIGN_V_CENTER];
        GuiTools.setAlignments(this.bg, bgAlignments);
        // set flag bg color
        var colorHex = ColorPalette.NameAsHexStr(this.factionFlag.bgColorName);
        this.bg.background = colorHex;
        // add shadow
        this.bg.shadowColor = "#0008";
        this.bg.shadowOffsetX = 0;
        this.bg.shadowOffsetY = 2;
        this.bg.shadowBlur = 5;
    };
    FactionFlagImage.prototype.addFlagIcon = function () {
        var iconId = this.name + "-icon";
        var flagIconPath = FLAG_ICON_FOLDER + "icon_" + this.factionFlag.iconName.toLowerCase() + ".png";
        console.log("<FactionFlag> showing flag icon \"".concat(flagIconPath, "\""));
        this.icon = new GUI.Image(iconId, flagIconPath);
        GuiTools.setSizeInPx(this.icon, SIZE_INNER_PX, SIZE_INNER_PX);
        this.icon.verticalAlignment = GUI_CONST.ALIGN_TEXT_V_TOP;
        this.icon.topInPixels = ICON_Y_OFFSET_PX;
        // icon shadow
        this.icon.shadowColor = ICON_SHADOW_COLOR_HEX;
        this.icon.shadowBlur = ICON_SHADOW_BLUR_PX;
        this.addControl(this.icon);
    };
    return FactionFlagImage;
}(GUI.Rectangle));
export { FactionFlagImage };
/* == FACTION FLAG CONSTANTS == */
export var FLAG_ICON_FOLDER = "./res/img/flags/icons/";
export var SIZE_INNER_PX = 32;
export var SIZE_INNER = "".concat(SIZE_INNER_PX, "px");
export var SIZE_OUTTER_PX = 80;
export var SIZE_OUTTER = "".concat(SIZE_OUTTER_PX, "px");
export var ICON_Y_OFFSET_PX = 22;
export var ICON_SHADOW_COLOR_HEX = "#0009";
export var ICON_SHADOW_BLUR_PX = 18;
//# sourceMappingURL=flags.js.map