var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import * as GUI_CONST from '../common/constants';
import { GuiRectangle } from '../common/rectangle';
// babylon
import * as GUI from 'babylonjs-gui';
import { GuiTools } from '../common/gui-tools';
var InlineIcon = /** @class */ (function (_super) {
    __extends(InlineIcon, _super);
    function InlineIcon(elemId, iconName, customSize, hasOwnBackground, hasShadow) {
        var _this = _super.call(this, elemId) || this;
        _this.hasOwnBackground = false;
        _this.iconSizeInner = ICON_SIZE_PX;
        if (customSize) {
            _this.iconSizeInner = customSize;
        }
        _this.initializeContainer();
        // background
        if (hasOwnBackground) {
            _this.createIconBackground();
        }
        // icon image
        if (iconName) {
            _this.iconName = iconName;
            _this.createIconImage();
        }
        // optional
        if (hasOwnBackground) {
            _this.hasOwnBackground = hasOwnBackground;
        }
        return _this;
    }
    InlineIcon.prototype.initializeContainer = function () {
        this.widthInPixels = this.iconSizeWithPadding;
        this.height = GUI_CONST.DEFAULT_LABEL_HEIGHT;
        this.thickness = 0;
        GuiTools.setFullPadding(this, ICON_PADDING);
    };
    InlineIcon.prototype.createIconBackground = function () {
        this.hasOwnBackground = true;
        var iconBgId = "".concat(this.name, "-bg");
        var iconBg = new GUI.Image(iconBgId, ICON_PATH_BG);
        iconBg.widthInPixels = this.iconSizeWithPadding;
        iconBg.heightInPixels = this.iconSizeWithPadding;
        this.addControl(iconBg);
    };
    InlineIcon.prototype.createIconImage = function (noShadow) {
        var iconId = "".concat(this.name, "-iconImg");
        this.iconImage = new GUI.Image(iconId, this.iconFilePath);
        this.iconImage.widthInPixels = this.iconSizeInner;
        this.iconImage.heightInPixels = this.iconSizeInner;
        if (!noShadow) {
            this.iconImage.shadowColor = GUI_CONST.SHADOW_COLOR_BRIGHT_HEX;
            this.iconImage.shadowBlur = 3;
        }
        this.addControl(this.iconImage);
    };
    InlineIcon.prototype.setIconImage = function (iconName) {
        this.iconName = iconName;
        var fullPath = this.iconFilePath;
        this.iconImage.source = fullPath;
    };
    Object.defineProperty(InlineIcon.prototype, "iconFilePath", {
        get: function () { return ICONS_FOLDER + this.iconName + ".png"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(InlineIcon.prototype, "iconSizeOutter", {
        get: function () { return this.iconSizeInner + 10; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(InlineIcon.prototype, "iconSizeWithPadding", {
        get: function () { return this.iconSizeOutter + 2 * (InlineIcon.DEFAULT_PADDING); },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(InlineIcon, "DEFAULT_PADDING", {
        /* STATIC GETTERS */
        get: function () { return ICON_PADDING_PX; },
        enumerable: false,
        configurable: true
    });
    return InlineIcon;
}(GUI.Rectangle));
export { InlineIcon };
var PropertyIconStack = /** @class */ (function (_super) {
    __extends(PropertyIconStack, _super);
    function PropertyIconStack() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return PropertyIconStack;
}(GuiRectangle));
export { PropertyIconStack };
/* == ICON CONSTANTS == */
export var ICONS_FOLDER = "res/img/icons/inline/";
export var ICON_PATH_BG = ICONS_FOLDER + "bg.png";
export var ICON_SHOW_BG = false;
// padding
export var ICON_PADDING_PX = 5;
export var ICON_PADDING = "".concat(ICON_PADDING_PX, "px");
// icon sizing
export var ICON_SIZE_PX = 20;
export var ICON_SIZE_OUTTER_PX = 30;
export var ICON_WIDTH_PX = ICON_SIZE_OUTTER_PX + 2 * ICON_PADDING_PX;
export var ICON_WIDTH_TOTAL_PX = ICON_WIDTH_PX;
export var ICON_WIDTH_TOTAL = "".concat(ICON_WIDTH_TOTAL_PX, "px");
//# sourceMappingURL=icons.js.map