var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import * as GUI_CONST from '../common/constants';
import { GuiRectangle } from '../common/rectangle';
import { GuiTools } from '../common/gui-tools';
// babylon
import * as GUI from 'babylonjs-gui';
var SectionHeader = /** @class */ (function (_super) {
    __extends(SectionHeader, _super);
    function SectionHeader(sectionName) {
        var _this = this;
        var elemId = "section-header-".concat(sectionName);
        // call super & set id & name
        _this = _super.call(this, elemId) || this;
        _this.sectionName = sectionName;
        // set babylon control size
        SectionHeader.setToSectionHeight(_this);
        // create inner controls
        _this.showBg();
        _this.showHeaderImage();
        _this.showHeaderTitle();
        return _this;
    }
    SectionHeader.prototype.showBg = function () {
        this.bgImage = new GUI.Image("".concat(this.name, ".bg"), GUI_CONST.BG_PAPER);
        this.bgImage.width = this.width;
        // set size
        SectionHeader.setToSectionHeight(this.bgImage);
        // add to SectionHeader container
        this.addControl(this.bgImage);
    };
    SectionHeader.prototype.showHeaderImage = function () {
        var headerImageId = "header-img";
        this.headerImage = new GUI.Image(headerImageId, GUI_CONST.BG_SECTION);
        // set size
        SectionHeader.setToSectionHeight(this.headerImage);
        // add to SectionHeader container
        this.addControl(this.headerImage);
    };
    SectionHeader.prototype.showHeaderTitle = function () {
        var headerTitleId = "header-title-text";
        this.headerTitle = new GUI.TextBlock(headerTitleId, this.sectionName);
        // set size
        SectionHeader.setToSectionHeight(this.headerTitle);
        // set font stype
        this.headerTitle.fontSize = GUI_CONST.TEXTSIZE_NORMAL;
        this.headerTitle.fontFamily = GUI_CONST.FONT_HIGHLIGHTED;
        GuiTools.setHighlightedFontColor(this.headerTitle);
        // add to SectionHeader container
        this.addControl(this.headerTitle);
    };
    SectionHeader.setToSectionHeight = function (control) {
        control.width = GUI_CONST.DEFAULT_INNER_WIDTH;
        control.height = SECTION_HEADER_HEIGHT;
    };
    return SectionHeader;
}(GuiRectangle));
export { SectionHeader };
/* == CONSTANTS == */
export var BG_HEADER_IMAGE = "bg_section.png";
export var SECTION_HEADER_HEIGHT = GUI_CONST.LOWER_ELEMNT_HEIGHT;
//# sourceMappingURL=section-header.js.map