var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import * as GUI_CONST from '../common/constants';
import * as GUI from 'babylonjs-gui';
// menues
import { AbstractMenu } from './common/abstract-menu';
var CircularButton = /** @class */ (function (_super) {
    __extends(CircularButton, _super);
    function CircularButton(btnId, horizontalAlign) {
        var _this = _super.call(this, CircularButton.ShortElementId(btnId)) || this;
        // children
        _this.inner = null;
        // image textures
        _this.cachedTextures = [];
        _this.btnId = btnId;
        // on screen position
        _this.verticalAlignment = GUI_CONST.ALIGN_V_CENTER;
        _this.horizontalAlignment = horizontalAlign;
        // sizing & offset
        _this.setSizeInPixels(CIRCBTN_SIZE_PX);
        _this.calculateOffset();
        // add inner image
        _this.addInnerImage();
        return _this;
    }
    CircularButton.prototype.calculateOffset = function () {
        this._addYOffset();
        this._addMarginOffset();
    };
    CircularButton.prototype.cacheTextures = function () {
    };
    CircularButton.prototype._addMarginOffset = function () {
        var marginXOffsetPx = GUI_CONST.BODY_MARGIN_X_PX;
        if (this.horizontalAlignment == GUI_CONST.ALIGN_H_RIGHT) {
            marginXOffsetPx *= -1;
        }
        this.leftInPixels = marginXOffsetPx;
    };
    CircularButton.prototype._addYOffset = function () {
        this.top = CIRCBTN_V_OFFSET;
    };
    CircularButton.prototype.addInnerImage = function () {
        // get name of button image in img/ui/buttons folder
        var innerImgId = CircularButton.FullElementId(this.btnId).replace("outter", "inner");
        var imageFilePath = CircularButton.ImagePath(this.btnId, false);
        this.inner = new GUI.Image(innerImgId, imageFilePath);
        // sizing
        this.inner.width = CIRCBTN_SIZE;
        this.inner.height = CIRCBTN_SIZE;
        // add to outter
        this.addControl(this.inner);
    };
    CircularButton.prototype.updateImage = function () {
        this.inner.source = CircularButton.ImagePath(this.btnId, this.isHovered);
    };
    CircularButton.ImagePath = function (btnId, isHovered) {
        var fileEnding = ".png";
        if (isHovered) {
            fileEnding = "-glowing.png";
        }
        return GUI_CONST.FOLDER_BUTTONS_IMG + CIRCBTN_ID_PREFIX + btnId + fileEnding;
    };
    CircularButton.FullElementId = function (btnId) {
        return CIRCBTN_ID_PREFIX_FULL + btnId + "-outter";
    };
    CircularButton.ShortElementId = function (btnId) {
        return CIRCBTN_ID_PREFIX + btnId;
    };
    CircularButton.prototype.onHover = function () {
        _super.prototype.onHover.call(this);
        this.updateImage();
    };
    CircularButton.prototype.onHoverEnd = function () {
        _super.prototype.onHoverEnd.call(this);
        this.updateImage();
    };
    return CircularButton;
}(AbstractMenu));
export { CircularButton };
export var CIRCBTN_ID_PREFIX = "circbtn-";
export var CIRCBTN_ID_PREFIX_FULL = "menu-circbtn-";
export var CIRCBTN_IMG_FILE_PREFIX = "circbtn-";
export var CIRCBTN_SIZE = "120px";
export var CIRCBTN_SIZE_PX = 120;
export var CIRCBTN_V_OFFSET = "18%";
export var CIRCBTN_ICON_FOLDER = "./res/img/ui/buttons/";
//# sourceMappingURL=circular-button.js.map