var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// trade
import { TradeConnection } from "../entities/trade/connection";
// managers
import { AbstractManager } from "./abstract-manager";
var ConnectionManager = /** @class */ (function (_super) {
    __extends(ConnectionManager, _super);
    function ConnectionManager() {
        var _this = _super.call(this, "Connection") || this;
        _this.connections = [];
        return _this;
    }
    ConnectionManager.prototype.makeCityConnections = function () {
        if (!globalThis.CITIES) {
            this.warn("cant create connections; CityManager not found");
            return;
        }
        this.log("creating city connections ..");
        var createdConnections = [];
        for (var _i = 0, _a = globalThis.CITIES.getAll(); _i < _a.length; _i++) {
            var city = _a[_i];
            var cityConnections = city.addConnections(TradeConnection.MAX_DISTANCE);
            createdConnections.concat(cityConnections);
        }
        // add city connections to manager connection list
        this.connections.concat(createdConnections);
    };
    ConnectionManager.prototype.fromTo = function (source, target) {
        for (var _i = 0, _a = source.connections; _i < _a.length; _i++) {
            var conn = _a[_i];
            if (conn.hasTarget(target)) {
                return conn;
            }
        }
        return;
    };
    ConnectionManager.prototype.getMirrored = function (connection) {
        var mirrored = this.fromTo(connection.target, connection.source);
        return mirrored;
    };
    return ConnectionManager;
}(AbstractManager));
export { ConnectionManager };
//# sourceMappingURL=connection-manager.js.map