var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// jquery
import * as $ from "jquery";
import * as EV from "../game-events";
// managers
import { AbstractManager } from "./abstract-manager";
var FileManager = /** @class */ (function (_super) {
    __extends(FileManager, _super);
    function FileManager() {
        var _this = _super.call(this, "File") || this;
        _this.jsonContent = {};
        _this._loadingErrors = [];
        return _this;
    }
    FileManager.prototype.loadJson = function (fullPath) {
        this.log("start loading character names from ".concat(fullPath));
        $.getJSON(fullPath)
            .done(function (data) {
            globalThis.FILES._onJsonLoaded(fullPath, data);
        })
            .fail(function () {
            globalThis.FILES.onLoadingError(fullPath);
        });
    };
    /* INTERNAL ON EVENT */
    FileManager.prototype._onJsonLoaded = function (fullPath, content) {
        var fileNameShort = FileManager.FileNameFromPath(fullPath, true);
        this.jsonContent[fileNameShort] = content;
        this.onJsonLoaded(fileNameShort, content);
    };
    FileManager.prototype.onLoadingError = function (fullPath) {
        var fileName = FileManager.FileNameFromPath(fullPath);
        this.warn("error while loading file \"".concat(fileName, "\"; aborted"));
        this._loadingErrors.push(fileName);
        // fire event
        var loadingErrorEvent = new EV.FileLoadingErrorEvent(fullPath);
        globalThis.EVENTS.fireEvent(loadingErrorEvent);
    };
    FileManager.prototype.onJsonLoaded = function (fileNameShort, content) {
        var contentKeys = Object.keys(content).length;
        this.log("file \"".concat(fileNameShort, "\" loaded with ").concat(contentKeys, " properties"));
    };
    FileManager.FileNameFromPath = function (fullPath, withoutEnding) {
        var splittedPath = fullPath.split("/");
        var filePath = splittedPath[splittedPath.length - 1];
        if (withoutEnding) {
            var nameAndEnding = filePath.split(".");
            return nameAndEnding[0];
        }
        return filePath;
    };
    /* EVENT HANDLING */
    FileManager.prototype.onEvent = function (ev) {
        _super.prototype.onEvent.call(this, ev);
    };
    /* GETTER METHODS */
    FileManager.prototype.fullJsonPath = function (shortName) { return this.DEFAULT_FILES_PREFIX + shortName + this.ENDING_JSON; };
    Object.defineProperty(FileManager.prototype, "DEFAULT_FILES_PREFIX", {
        /* PATH CONSTANTS */
        get: function () { return "./res/data/default/default-"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FileManager.prototype, "ENDING_JSON", {
        get: function () { return ".json"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FileManager.prototype, "DEFAULT_LANG_JSON_PATH", {
        get: function () { return this.fullJsonPath("languages"); },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FileManager.prototype, "DEFAULT_MOUNTS_JSON_PATH", {
        get: function () { return this.fullJsonPath("unit-mounts"); },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FileManager.prototype, "DEFAULT_GEAR_JSON_PATH", {
        get: function () { return this.fullJsonPath("unit-gear"); },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FileManager.prototype, "DEFAULT_BLDTYPES_JSON_PATH", {
        get: function () { return this.fullJsonPath("building-types"); },
        enumerable: false,
        configurable: true
    });
    return FileManager;
}(AbstractManager));
export { FileManager };
//# sourceMappingURL=file-manager.js.map