var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { WorldTools } from "../../helpers/world-tools";
// manager
import { AbstractManager } from "./abstract-manager";
// gui
import { PlayerInfoDialog } from "../gui/dialogs/player-dialog";
var PlayerManager = /** @class */ (function (_super) {
    __extends(PlayerManager, _super);
    function PlayerManager() {
        return _super.call(this, "Player") || this;
    }
    PlayerManager.prototype.movePlayerTo = function (newPos) {
        var playerStartPos = globalThis.PLAYER.pos;
        globalThis.PLAYER.setPos(newPos, null, playerStartPos);
    };
    PlayerManager.prototype.getPlayerCursorSceneDistance = function () {
        var playerMesh = globalThis.PLAYER.mesh;
        var cursorMesh = globalThis.SELECTION.cursorMesh;
        return WorldTools.getMeshDistance(playerMesh, cursorMesh);
    };
    /* INTERNAL IN EVENT */
    PlayerManager.prototype.onPlayerClicked = function () {
        this.log("clicked on player");
        var playerDiag = new PlayerInfoDialog();
        globalThis.GUI.showDialog(playerDiag);
    };
    PlayerManager.prototype.beforePlayerMovement = function (targetPos) {
        globalThis.SELECTION.setSourceToPlayer();
    };
    PlayerManager.prototype.beforeValidPlayerMovement = function (targetPos) {
    };
    PlayerManager.prototype.canMoveTo = function (targetPos) {
        var playerPos = globalThis.PLAYER.pos;
        var sceneDist = WorldTools.getWorldPosDistance(targetPos, playerPos);
        this.log("dist to player target: ".concat(sceneDist));
        return true;
    };
    PlayerManager.prototype.afterPlayerMovement = function () {
        globalThis.PLAYER.updatePlayerYPos();
        // 4. city entered or left?
        globalThis.PLAYER.checkCityEnterLeave();
        globalThis.TURNS.onEndTurnButton();
    };
    PlayerManager.prototype.checkOnEntered = function () {
    };
    PlayerManager.prototype.onEvent = function (ev) {
    };
    return PlayerManager;
}(AbstractManager));
export { PlayerManager };
//# sourceMappingURL=player-manager.js.map