var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as EV from "../game-events";
// models
import { Turn } from "../../common/turn";
// manager
import { AbstractManager } from "./abstract-manager";
var TurnManager = /** @class */ (function (_super) {
    __extends(TurnManager, _super);
    function TurnManager() {
        var _this = _super.call(this, "Turn") || this;
        _this.pastTurns = [];
        _this.active = null;
        _this.active = new Turn(0);
        return _this;
    }
    TurnManager.prototype.turnNum = function () {
        return this.active.num;
    };
    TurnManager.prototype.onEndTurnButton = function () {
        // this.log(`End Turn button clicked`);
        // processing & fire turn finished event
        this.active.nextStage();
        globalThis.EVENTS.fireEvent(new EV.PlayerTurnFinishedEvent(this.active.num));
        // put after turn processing here
        globalThis.CITIES._onTurnFinished();
        // finishing
        this.active.nextStage();
    };
    TurnManager.prototype.onTurnFinished = function (turn) {
        // finishing
        this.startNextTurn();
    };
    TurnManager.prototype.startNextTurn = function () {
        var oldTurn = this.active;
        var nextTurnNum = oldTurn.num + 1;
        this.pastTurns.push(oldTurn);
        this.active = new Turn(nextTurnNum);
        // fire before turn started event
        globalThis.EVENTS.fireEvent(new EV.BeforeTurnStartedEvent(this.active.num));
        // fire turn started Event
        globalThis.EVENTS.fireEvent(new EV.TurnStartedEvent(this.active.num));
        this.log("started turn ".concat(this.active));
    };
    return TurnManager;
}(AbstractManager));
export { TurnManager };
//# sourceMappingURL=turn-manager.js.map