var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as EV from "../game-events";
// entities
import { Unit } from "../entities/unit/unit";
import { UnitTypes } from "../entities/unit/unit-types";
// manager
import { AbstractManager } from "./abstract-manager";
var UnitManager = /** @class */ (function (_super) {
    __extends(UnitManager, _super);
    function UnitManager() {
        var _this = _super.call(this, "Unit") || this;
        // lastArmyNum: number = -1;
        _this.units = [];
        return _this;
        // this.initializeUnitTypes();
    }
    UnitManager.prototype.createUnit = function (typeId, pos) {
        var instance = new Unit(typeId, pos);
        this.units.push(instance);
        this.onUnitSpawned(instance);
        return instance;
    };
    /* UNIT TYPES */
    UnitManager.prototype.initializeUnitTypes = function () {
        this.log("start unit type initialization");
        globalThis.UNIT_TYPES = new UnitTypes();
        // fire event
        var typesLoadedEvent = new EV.UnitTypesInitializedEvent(globalThis.UNIT_TYPES.getAll().length);
        globalThis.EVENTS.fireEvent(typesLoadedEvent);
        // inform faction manager
        globalThis.FACTIONS.onUnitTypesInitialized();
    };
    UnitManager.prototype.isValidUnitTypeId = function (unitTypeId) {
        if (!globalThis.UNIT_TYPES) {
            this.warn("cant check whether \"".concat(unitTypeId, "\" is valid; UnitType list not found"));
            return false;
        }
        return globalThis.UNIT_TYPES.isValidUnitTypeId(unitTypeId);
    };
    UnitManager.prototype.getUnitTypeById = function (unitTypeId) {
        return globalThis.UNIT_TYPES.get(unitTypeId);
    };
    /* UNIT AND ARMY NUMBERS */
    UnitManager.prototype.nextUnitId = function () {
        return this.units.length;
    };
    /* ON EVENTS */
    UnitManager.prototype.onEvent = function (ev) {
        _super.prototype.onEvent.call(this, ev);
        return true;
    };
    UnitManager.prototype.onUnitSpawned = function (newUnit) {
    };
    UnitManager.prototype.onCitiesLoaded = function () {
        // globalThis.ARMIES.createStartingArmies();
    };
    UnitManager.prototype.onGearTypesLoaded = function () {
        this.initializeUnitTypes();
    };
    return UnitManager;
}(AbstractManager));
export { UnitManager };
//# sourceMappingURL=unit-manager.js.map