// world
import { WorldPos } from "./pos";
/* == MODEL == */
var LandscapeFeature = /** @class */ (function () {
    function LandscapeFeature(id, x, z) {
        this.id = id;
        this.pos = new WorldPos(x, z);
    }
    LandscapeFeature.FromString = function (landscapeFeatureStr) {
        var featureData = landscapeFeatureStr.split(" ");
        var featureId = featureData[0];
        var featurePosStr = featureData[1] + " " + featureData[2];
        var featurePos = WorldPos.FromString(featurePosStr);
        var landscapeFeature = new LandscapeFeature(featureId, featurePos.x, featurePos.z);
        return landscapeFeature;
    };
    return LandscapeFeature;
}());
export { LandscapeFeature };
/* == CONSTANTS == */
// ids
export var FEATURE_FOREST = "forest";
export var FEATURE_FOREST_NORTHERN = "forest-northern";
export var FEATURE_FOREST_SOUTHERN = "forest-southern";
export var FEATURE_TREASURE = "treasure";
export var FEATURE_SHIPWRECK = "shipwreck";
export var FEATURE_VOLCANO = "volcano";
//# sourceMappingURL=feature.js.map