// common
import { Loggable } from "../../../../common/log";
// entities
import { IFaction, AbstractFaction } from "../faction";
import { IDiplomaticTreaty } from "./treaty";

export interface IFactionDiplomacy {
    parentFaction: IFaction;
    treaties: Array<IDiplomaticTreaty>;
}

export class FactionDiplomacy extends Loggable implements IFactionDiplomacy {
    parentFaction: IFaction;
    treaties: Array<IDiplomaticTreaty> = [];

    constructor(parentFaction: IFaction) {
        super("Diplomacy");
        this.parentFaction = parentFaction;
    }

    toString(): string {
        return `<FactionDiplomacy "${this.parentFaction.name}">`;
    }
}

