// entities
import { City} from "../../entities/city/city";
import { TradeConnection } from "../../entities/trade/connection/connection";
// gui
import * as GUI_CONST from '../common/constants';
import { EmptyDialog, IDialog } from "./common/base-dialog";
import { SingleDataRow } from "../elements/data-row";
// babylon
import * as GUI from 'babylonjs-gui';

/* == CITY CONNECTIONS DIALOG == */
export class CityConnectionsDialog extends EmptyDialog {
    city: City;
    connections: Array<TradeConnection> = [];

    constructor(city: City) {
        super(DIAG_CONNECTIONS, false, `Connections: ${city.name}`);
        this.city = city;
        this.connections = city.connections;
    }

    addCustomContent(): void {
        for (const connection of this.connections) {
            const cityName = connection.target.name;
            const cityWorldDist = connection.worldDistance;
            const keyStr = cityName;
            const valueStr = `${cityWorldDist} (${connection.doneTrades} Trades for ${connection.tradedCoins}c)`;
            this.addNewDataRow(keyStr, valueStr, "connection");
        }
    }

    public build(): void {
        super.build();
    }
}

/* == CONTSANTS == */
// connections dialog
export const DIAG_CONNECTIONS = "diag-connections";