// common
import { Loggable } from "../common/log";
// world
import { WorldPos } from "../game/world/pos";
import { WorldTile } from "../game/world/tile/tile";
import { tileAt } from "../game/world/map";

export class TilePathFinder extends Loggable {
    sourcePos: WorldPos;
    targetPos: WorldPos;
    // tiles
    startTile: WorldTile;

    constructor(sourcePos: WorldPos, targetPos: WorldPos) {
        super("TilePathFinder");
        this.sourcePos = sourcePos;
        this.targetPos = targetPos;
        this.startTile = tileAt(sourcePos.x, sourcePos.z);
    }

    findSimplePosPath(): Array<WorldPos> {
        let posArr: Array<WorldPos> = [];
        let lastPos: WorldPos = this.sourcePos;
        let isAtTarget = lastPos.equals(this.sourcePos);
        while (! isAtTarget ) {
            const oldPos = lastPos;
            posArr.push( oldPos );
            // lastPos = this.findNextSimplePos( oldPos );

        }
        return posArr;
    }
}